module.exports = function (app) {

  app.config([
    'formioComponentsProvider',
    function(formioComponentsProvider) {
      formioComponentsProvider.register('datetime', {
        title: 'Date / Time',
        template: 'formio/components/datetime.html',
        tableView: function(data) {
          return '<span>{{ "' + data + '" | date: "' + this.settings.format + '" }}</span>';
        },
        settings: {
          input: true,
          tableView: true,
          label: '',
          key: 'datetimeField',
          placeholder: '',
          format: 'yyyy-MM-dd HH:mm',
          enableDate: true,
          enableTime: true,
          minDate: null,
          maxDate: null,
          datepickerMode: 'day',
          datePicker: {
            showWeeks: true,
            startingDay: 0,
            initDate: '',
            minMode: 'day',
            maxMode: 'year',
            yearRange: '20'
          },
          timePicker: {
            hourStep: 1,
            minuteStep: 1,
            showMeridian: true,
            readonlyInput: false,
            mousewheel: true,
            arrowkeys: true
          },
          protected: false,
          persistent: true,
          validate: {
            required: false,
            custom: ''
          }
        }
      });
    }
  ]);
  app.run([
    '$templateCache',
    'FormioUtils',
    function($templateCache, FormioUtils) {
      $templateCache.put('formio/components/datetime.html', FormioUtils.fieldWrap(
        '<div class="input-group">' +
        '<input type="text" class="form-control" ' +
        'ng-focus="calendarOpen = true" ' +
        'ng-click="calendarOpen = true" ' +
        'ng-init="calendarOpen = false" ' +
        'ng-disabled="readOnly" ' +
        'ng-required="component.validate.required" ' +
        'is-open="calendarOpen" ' +
        'datetime-picker="{{ component.format }}" ' +
        'min-date="component.minDate" ' +
        'max-date="component.maxDate" ' +
        'datepicker-mode="component.datepickerMode" ' +
        'enable-date="component.enableDate" ' +
        'enable-time="component.enableTime" ' +
        'ng-model="data[component.key]" ' +
        'placeholder="{{ component.placeholder }}" ' +
        'datepicker-options="component.datePicker" ' +
        'timepicker-options="component.timePicker" />' +
        '<span class="input-group-btn">' +
        '<button type="button" class="btn btn-default" ng-click="calendarOpen = true">' +
        '<i ng-if="component.enableDate" class="glyphicon glyphicon-calendar"></i>' +
        '<i ng-if="!component.enableDate" class="glyphicon glyphicon-time"></i>' +
        '</button>' +
        '</span>' +
        '</div>'
      ));
    }
  ]);
};
